#!/usr/bin/perl

# reads stats and uptime from df and pstat for mrtg

$file_system  = ($ARGV[0] or "swap");
$pattern      = ($ARGV[1] or "TU");
$format       = ($ARGV[2] or "1024");
$pattern=substr "$pattern  ",0,2;

if ($file_system eq 'swap') {
 $data = `/usr/sbin/pstat -k -s`;
} else {
 $data = `/bin/df -k $file_system`;
}

($fs_avail,$fs_used,$fs_total)=(0,0,0); $data=~s/.*\n//; chomp $data;
($fs_dev,$fs_total,$fs_used,$fs_avail,$fs_cmt,$fs_name) = split m[\s+], $data;
if ($file_system eq 'swap') {$fs_name="swap: $fs_name"};

$result=''; for (split //,$pattern) {
 $result.=$format*$fs_used."\n",next  if lc$_ eq 'u';
 $result.=$format*$fs_avail."\n",next if lc$_ eq 'a';
 $result.=$format*$fs_total."\n",next if lc$_ eq 't';
 $result.="0\n";
}

$uptime=$1 if ($record=`/usr/bin/uptime`)=~m[up\s+(.*?,.*?),];
print "$result$uptime\n$fs_name\n";

